def array(N1, N2=0,N3=0,init=0):   #■配列宣言
    if N2==0: return [init for i in range(N1)]
    if N3==0: return [[init for i in range(N2)]
                      for j in range(N1)]
    return[[[init for i in range(N3)]for j in range(N2)]
           for k in range(N1)]
def cID(N,X):#■枠外ID枠内IDにする
    if   X<0: return X + N
    elif X>=N: return X - N
    return X
def Hindu(N):#■ヒンズーの連続方式
    A=array(N,N); ii=0;jj=int(N/2)
    A[ii][jj]=1
    for k in range(2, N*N+1):
        i0=ii;j0=jj;ii=cID(N,ii-1);jj=cID(N,jj+1)
        if A[ii][jj]!=0: ii=cID(N,i0+1);jj=j0
        A[ii][jj]=k
    return A
def Bashe(N):#■バシェー方式
    A=array(N,N); k=0;N2=int(N/2)
    for i in range(-N2,N2+1):
        for j in range(0,N):
            k+=1; 
            A[cID(N,j+i)][cID(N,j-i)]=k
    return A
def keima(N):#■桂馬飛び法
    A=array(N,N);ii=0;jj=0;jj=int(N/2)
    #ii=int(N/2);jj=int(N/2)
    A[ii][jj]=1
    for k in range(2, N*N+1):
        i0=ii;j0=jj;ii=cID(N,i0+2);jj=cID(N,j0+1)
        if A[ii][jj]!=0: ii=cID(N,i0+1);jj=cID(N,j0-1)
        if A[ii][jj]!=0: ii=cID(N,i0+1);jj=cID(N,j0)
        if A[ii][jj]!=0: print("失敗"); return A
        A[ii][jj]=k
    return A
def checkComplete(A):
    N=len(A);TT=array(N)
    print("■右下がり方向チェック")
    
    for i in range(N):
        T=0;
        for j in range(N):T+=A[j][cID(N,i+j)]
        TT[i]=T
    print(TT)
    print("■右上がり方向チェック")
    for i in range(N):
        T=0;
        for j in range(N):T+=A[j][cID(N,i-j)]
        TT[i]=T
    print(TT)
def printSQR(RL,N):#■魔方陣の表示
    T=0            #　右上がり方向対角和表示 
    for i in range(N):T+=RL[i][N-i-1]
    S="    |%6d"% T
    print(" "*(N*6)+S,"(対角和)")
    print("   ","-"*(N*6)+"+")   #区切り表示
    for i in range(N):# 魔方陣内数字と横方向の和表示
        S="   ";T=0
        for j in range(N):
            S+="%6d"%RL[i][j]; T+=RL[i][j]
        S+=" |%6d"% T
        print(S)
    S="  "         # 縦方向の和計算と文字列変換
    for j in range(N):
        T=0
        for i in range(len(RL)):T+=RL[i][j]
        S+="%6d"% T
    T=0         #　右上がり方向対角和表示 
    for i in range(N):T+=RL[i][i]
    S+=" |%6d"% T
    print("   ","-"*(N*6)+"+\n",S, "(対角和)")

N=5

#print("\n■ヒンズーの連続方式による%d×%d"%(N,N))
#A=Hindu(N)
#printSQR(A,N)
#print("\n■バシェー方式による%d×%d"%(N,N))
#A=Bashe(N)
#printSQR(A,N)
print("\n■桂馬飛び法による%d×%d"%(N,N))
A=keima(N)
printSQR(A,N)
checkComplete(A)
            
            
